<?php


if ( ! defined( 'ABSPATH' ) ) exit;

if ( !class_exists('Wcap_Email_Settings' ) ) {
    
    class Wcap_Email_Settings{

        
        public static function wcap_display_email_setting( ) {
            
            ?>
            <p><?php _e( 'در این بخش می‌توانید تنظیمات کلی پلاگین را تغییر دهید. لطفا بخش‌ها را با دقت مطالعه فرمایید.', 'xcart-tr' ); ?></p>
            <div id="wcap_content">

            <?php
                $wcap_general_settings_class = $wcap_license = $wcap_fb_settings = $wcap_sms_settings = $wcap_add_to_cart = $section = "";
                
                $section = isset( $_GET[ 'wcap_section' ] ) ? $_GET[ 'wcap_section' ] : '';

                switch( $section ) {
                    
                    case 'wcap_general_settings':
                    case '':
                        $wcap_general_settings_class = "current";
                        break;
                    case 'wcap_cron_settings':
                        $wcap_cron_setting = "current";
                        break;
                    case 'wcap_block_settings':
                        $wcap_block_settings = "current";
                        break;
                    case 'wcap_atc_settings':
                        $wcap_add_to_cart = "current";
                        break;
                    case 'wcap_sms_settings':
                        $wcap_sms_settings = 'current';
                        break;
                }
                ?>
             
                <br class="clear">
                <?php
                if ( $section == 'wcap_general_settings' || $section == '' ) {
                ?>
                <style>tr{background: white; margin: 10px !important; padding: 10px !important; display: block; border-radius: 10px; box-shadow: 1px 2px 3px 1px #dbdbdb !important;}</style>
                    <form method="post" action="options.php">
                        <?php settings_fields     ( 'woocommerce_ac_settings' ); ?>
                        <?php do_settings_sections( 'xcart' ); ?>
                        <?php settings_errors(); ?>
                        <?php submit_button(); ?>
                    </form>
                    <?php
                }else if( $section == 'wcap_sms_settings' ) {
                    Wcap_SMS_settings::wcap_sms_settings();
                }else if ( $section == 'wcap_atc_settings' ) {
                    
                    if ( isset( $_POST['atc_settings_frm'] ) && 'save' == $_POST['atc_settings_frm'] ) {
                        Wcap_Add_Cart_Popup_Modal::wcap_add_to_cart_popup_save_settings( );
                        
                    }
                    wp_enqueue_script( 'wcap_atc_color_picker',   WCAP_PLUGIN_URL . '/assets/js/admin/atc_color_picker.min.js' );

                    wp_localize_script( 'wcap_atc_color_picker', 'wcap_atc_color_picker_params', array(
                                        'wcap_atc_head'  => get_option('wcap_heading_section_text_email'),
                                        'wcap_atc_text'  => get_option('wcap_text_section_text'),
                                        'wcap_atc_email_place'  => get_option('wcap_email_placeholder_section_input_text'),
                                        'wcap_atc_button'  => get_option('wcap_button_section_input_text'),
                                        'wcap_atc_button_bg_color'  => get_option('wcap_button_color_picker'),
                                        'wcap_atc_button_text_color'=> get_option('wcap_button_text_color_picker'),
                                        'wcap_atc_popup_text_color' => get_option('wcap_popup_text_color_picker'),
                                        'wcap_atc_popup_heading_color' => get_option('wcap_popup_heading_color_picker'),
                                        'wcap_atc_non_mandatory_input_text' => get_option('wcap_non_mandatory_text'),
                    ) );
                    
                    wp_enqueue_script( 'wcap_atc_vue_field_data', WCAP_PLUGIN_URL . '/assets/js/admin/atc_vue_field_data.min.js' );
                    wp_localize_script( 'wcap_atc_vue_field_data', 'wcap_vue_field_data_params', array(
                                        'wcap_atc_head'  => get_option('wcap_heading_section_text_email'),
                                        'wcap_atc_text'  => get_option('wcap_text_section_text'),
                                        'wcap_atc_email_place'  => get_option('wcap_email_placeholder_section_input_text'),
                                        'wcap_atc_button'  => get_option('wcap_button_section_input_text'),
                                        'wcap_atc_button_bg_color'  => get_option('wcap_button_color_picker'),
                                        'wcap_atc_button_text_color'=> get_option('wcap_button_text_color_picker'),
                                        'wcap_atc_popup_text_color' => get_option('wcap_popup_text_color_picker'),
                                        'wcap_atc_popup_heading_color' => get_option('wcap_popup_heading_color_picker'),
                                        'wcap_atc_non_mandatory_input_text' => get_option('wcap_non_mandatory_text'),
                    ) );

                    ?>
                    <form method="post" action="admin.php?page=xcart&action=emailsettings&wcap_section=wcap_atc_settings">
                        <input type="hidden" name="atc_settings_frm" value="save">
                        <?php Wcap_Add_Cart_Popup_Modal::wcap_add_to_cart_popup_settings(); ?>
                    </form>
                    <?php
                }
                do_action( 'wcap_add_custom_settings_tab_content', $section );
                ?>
            </div>
        <?php
        }
    }
}