<?php


// Exit if accessed directly
if ( ! defined('ABSPATH')) {
    exit;
}

// Get the PHP helper library from twilio.com/docs/php/install
// delete 

if ( ! class_exists('Wcap_SMS_settings')) {
    
    class Wcap_SMS_settings
    {
        
        public function __construct()
        {
        }

        
        public static function wcap_sms_settings()
        {
            ?>
            <form method="post" action="options.php">
                <?php
                settings_errors();
                settings_fields('woocommerce_sms_settings');
                do_settings_sections('woocommerce_ac_sms_page');
                submit_button();
                ?>
            </form>
          
            <?php
        }

        
        static function wcap_send_test_sms()
        {
            $msg_array = array();

            $phone_number = (isset($_POST['number'])) ? $_POST['number'] : 0;

            $msg = (isset($_POST['msg']) && $_POST['msg'] != '') ? $_POST['msg'] : '';

            if ($phone_number != '' && $msg != '') {
                // Verify the Phone number
                if (is_numeric($phone_number)) {
                    if (function_exists('wp_sms_send')) {
                        $to[] = $phone_number;
                        $response = wp_sms_send($to, $msg);
                        if(!is_wp_error($response)) {
                            $msg_array[] = __('SMS sent', 'xcart-tr');
                        } else {
                            $msg_array[] = __('ERROR', 'xcart-tr');
                        }
                    } else {
                        $msg_array[] = __('SMS plugin not exists', 'xcart-tr');
                    }
                } else {
                    $msg_array[] = __('Please enter the phone number in E.164 format', 'xcart-tr');
                }
            } else { // Phone number/Msg has not been provided
                $msg_array[] = __(
                    'Please make sure the Recipient Number and Message field are populated with valid details.',
                    'xcart-tr'
                );
            }

            echo json_encode($msg_array);
            die();
        }
    } // end of class
    $wcap_SMS_settings = new Wcap_SMS_settings();
}
